/** 
 * Copyright (C) 2008 Alan Ross, ( http://lab.adjazent.com )
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
package 
{
	import ar.particlepainter.paint.*;
	
	import flash.display.*;
	import flash.events.*;
	import flash.filters.BlurFilter;	

	[SWF(width='800',height='500',frameRate='255',backgroundColor='0x000000')]
	public class ParticlePainter extends Sprite 
	{
		//[Embed(source="../samples/sample.jpg")] private var Sample:Class;
		
		private var _paint: IPaint;
	
		private var _canvas: BitmapData;
		
		private var _mouseDown: Boolean = false;
		
		public function ParticlePainter() 
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
        	stage.align = StageAlign.TOP_LEFT;
        	stage.quality = StageQuality.HIGH;
        	stage.frameRate = 255;
			
			_canvas = new BitmapData( 800, 500, true, 0 );
			
			
			//-------------------------------------------- ShapePaint
			//_paint = new ShapePaint( _canvas );
			//addChild( new Bitmap( _canvas ) );

			//-------------------------------------------- BloodPaint
			_paint = new BloodPaint( _canvas );
        	addChild( new Bitmap( _canvas ) ).filters = [ new BlurFilter( 2, 2, 2 ) ]; //Blood paint effect

			//-------------------------------------------- NoiseSandPaint
			//_paint = new NoiseSandPaint( _canvas );
			//addChild( new Bitmap( _canvas ) );
			
			//-------------------------------------------- SprayPaint
			//_paint = new SprayPaint( _canvas );
			//addChild( new Bitmap( _canvas ) );
			
			//-------------------------------------------- DistortSpikePaint
			//_canvas.draw( new Sample() ); 
			//_paint = new DistortSpikePaint( _canvas );
			//addChild( new Bitmap( _canvas ) );
			
        	//addChild( new Stats() );
        	
			stage.addEventListener( Event.ENTER_FRAME, render );
			stage.addEventListener( MouseEvent.MOUSE_DOWN, function( e: MouseEvent ): void{ _mouseDown = true; } );
			stage.addEventListener( MouseEvent.MOUSE_UP, function( e: MouseEvent ): void{ _mouseDown = false; } );
		}

		private function render( e: Event ): void
		{
			_paint.paint( mouseX, mouseY, _mouseDown );
		}
	}
}


