/** 
 * Copyright (C) 2008 Alan Ross, ( http://lab.adjazent.com )
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
package ar.particlepainter.particles
{
	import ar.particlepainter.particles.Particle;
	
	import flash.display.BitmapData;	

	/**
	 * @author Alan Ross
	 */
	public class SprayParticleSpeckle extends SprayParticle
	{
		/**
		 * Create a new <code>SprayParticleSpeckle</code> object.
		 */
		public function SprayParticleSpeckle()
		{
			lifespan = 1;
			
			size = Math.random() * 2;
			
			viscosity = 0.1;
		}
		
		/**
		 * @inheritDoc
		 */
		override public function paint( b: BitmapData ): void
		{
			alpha = alpha * 0.5;
			
			b.setPixel32( x, y, alpha << 24 | color );
		}
	}
}
