/** 
 * Copyright (C) 2008 Alan Ross, ( http://lab.adjazent.com )
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
package ar.particlepainter.particles
{
	import flash.display.BitmapData;				

	/**
	 * @author Alan Ross
	 */
	public class SprayParticleThick extends SprayParticle
	{
		private const PI2: Number = Math.PI * 2;
		
		private var n: int;
		private var arcRand: Number;
		private var px: int;
		private var py: int;
		
		/**
		 * Create a new <code>SprayParticleThick</code> object.
		 */
		public function SprayParticleThick()
		{
			lifespan = ( Math.random() > 0.9 ) ? 1 + ( 30 * Math.random() ) : 1 + ( 15 * Math.random() );
			size = Math.random() * 9;
			if( size < 4 ) size = 4;
			viscosity = 0.1;
		}

		/**
		 * @inheritDoc
		 */
		override public function paint( b: BitmapData ): void
		{
			//alpha = alpha * 0.9;
			
			color32 = ( ( alpha << 24 ) | color );
			
			n = 15;
			
			while( --n > -1)
			{
				arcRand = Math.random() * PI2;
				
				px = x + ( Math.sin( arcRand ) * ( size * ( ( restLife / lifespan ) ) ) );
				py = y + ( Math.cos( arcRand ) * ( size * ( ( restLife / lifespan ) ) ) );
				
				//px = x + ( Math.sin( arcRand ) * ( size / 2 * Math.random() ) );
				//py = y + ( Math.cos( arcRand ) * ( size / 2 * Math.random() ) );
				
				b.setPixel32( px, py, color32 );
			}
		}
	}
}
